package WebSphereSamples.YourCo.Timeout;

// General enterprise bean code.
import java.rmi.RemoteException;
import javax.ejb.FinderException;

// Enterprise bean code specific for this servlet.
import WebSphereSamples.YourCo.Timeout.AccessHome;
import WebSphereSamples.YourCo.Timeout.Access;
import WebSphereSamples.YourCo.Timeout.History;
import WebSphereSamples.YourCo.Timeout.Leave;

// necessary only while EJB and servlet are in different packages
import WebSphereSamples.YourCo.Timeout.InsufficientLeaveException;

// Imports
import com.ibm.servlet.*;
import com.ibm.webtools.runtime.*;

// JNDI (naming).
import javax.naming.*;  // for Context, InitialContext, NamingException

import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;


// Imports for beans used by this servlet

import WebSphereSamples.YourCo.Meeting.InviteesDBBean;
import WebSphereSamples.YourCo.Timeout.TimeoutBean;
import WebSphereSamples.YourCo.Login.SessionBean;


public class TotalLeaveServlet extends com.ibm.webtools.runtime.StudioPervasiveServlet implements Serializable

{
	// Enterprise bean access.
   private AccessHome accessHome = null;

/**
 * Insert the method's description here.
 * Creation date: (9/16/2001 3:11:07 PM)
 * @return WebSphereSamples.YourCo.Timeout.TotalLeaveBean
 * @param request javax.servlet.http.HttpServletRequest
 */
public TotalLeaveBean calcTotalLeave(HttpServletRequest request) {
    Access access = null;
    TotalLeaveBean totalLeaveInfo = new TotalLeaveBean();
    int totalVactional = 0;
    int totalPersonal = 0;
    int totalSick = 0;
    int ii = 0;
    // Create an Access object.
    try {
        if (accessHome == null) {
            accessHome = getAccessHome(request);
        }
        access = accessHome.create();

        //Integer totalCount = new Integer(6); 
        // Uncomment the following line to aid in debugging DB servlets.
        // This can help isolate problems when the servlet appears to be unable to make
        // a connection to the database. You must recompile, republish, and then shutdown and
        // restart the server for this change to take effect. 
        // java.sql.DriverManager.setLogStream(System.out);

        try {

            // instantiate the beans and store them so they can be accessed by the called page
            WebSphereSamples.YourCo.Meeting.InviteesDBBean InviteesDBBean =
                new WebSphereSamples.YourCo.Meeting.InviteesDBBean();
            //setRequestAttribute("InviteesDBBean", InviteesDBBean, request);

            //setRequestAttribute("TotalCount", totalCount, request);

            // Initialize the bean userID property from the parameters
            System.out.println(
                "TL - userID: " + getParameter(request, "userID", true, true, false, null));
            InviteesDBBean.setUserID(
                getParameter(request, "userID", true, true, false, null));

            // Initialize the bean password optional property from the parameters
            System.out.println(
                "TL - pwd: " + getParameter(request, "password", true, true, false, null));
            InviteesDBBean.setPassword(
                getParameter(request, "password", true, true, false, null));

            // Initialize the bean URL property from the parameters
            System.out.println(
                "TL - url: " + getParameter(request, "URL", true, true, false, null));
            InviteesDBBean.setURL(getParameter(request, "URL", true, true, false, null));

            // Initialize the bean driver property from the parameters
            System.out.println(
                "TL - driver: " + getParameter(request, "driver", true, true, false, null));
            InviteesDBBean.setDriver(
                getParameter(request, "driver", true, true, false, null));

            // Initialize the bean dataSourceName optional property
            InviteesDBBean.setDataSourceName(
                getParameter(request, "dataSourceName", true, true, false, null));

            // Call the execute action on the bean.
            System.out.println("TL - execute DBBean");
            InviteesDBBean.execute();
            System.out.println("TL - loop through results");
            // Call the output page. If the output page is not passed
            // as part of the URL, the default page is called.

            int employeeId = 0;

            try {
                while (true) {
                    ii = ii + 1;

                    employeeId = Integer.valueOf(InviteesDBBean.getEMPNO(ii)).intValue();

                    System.out.println(
                        "Employee id: " + employeeId + " String: " + InviteesDBBean.getEMPNO(ii));

                    try {
                        totalVactional = totalVactional + access.getBalance(employeeId, 1);

                        totalPersonal = totalPersonal + access.getBalance(employeeId, 2);

                        totalSick = totalSick + access.getBalance(employeeId, 3);

                        System.out.println("tv:" + access.getBalance(employeeId, 1));
                    } catch (Exception e) {
                        System.out.println("TL - Exception: " + e.getMessage());
                        e.printStackTrace();
                    }
   
                } // End while
            } // End try
            catch (Exception e) {
                System.out.println("TL - Exception: " + e.getMessage());
                e.printStackTrace();
            }

            System.out.println("TL - save results");
            totalLeaveInfo.setTotalValues(totalVactional, totalPersonal, totalSick, ii);

        } // End Try

        catch (Exception e) {
            // uncomment the following line when unexpected exceptions are occuring to aid in debugging the problem
            // theException.printStackTrace();
            System.out.println("TL - Exception: " + e.getMessage());
            e.printStackTrace();
        }
    } catch (Exception e) {
        System.out.println("Exception: " + e.getMessage());
        e.printStackTrace();
    }
    return totalLeaveInfo;
}
/**
 * Insert the method's description here.
 * Creation date: (9/14/2001 11:41:40 AM)
 * @return WebSphereSamples.YourCo.Timeout.AccessHome
 * @param request javax.servlet.http.HttpServletRequest
 */
protected AccessHome getAccessHome(HttpServletRequest request) {
     AccessHome aHome = null;

      try
      {
         // Get parameters from .servlet file 
         String factory     = getParameter(request, "factory", true, true, false, null);
         String accessName  = getParameter(request, "accessName", true, true, false, null);
         String providerURL = getParameter(request, "providerURL", true, true, false, null);

         // Get home object for Access enterprise bean access.
         Hashtable env = new Hashtable();
         env.put(Context.PROVIDER_URL, providerURL);
         env.put(Context.INITIAL_CONTEXT_FACTORY, factory);

         // Create the initial context.

         System.out.println("TL - creating ctx");
         Context ctx = new InitialContext(env);
    
         // Get the home object.
            System.out.println("TL - getting home object" + ctx.toString());
         Object homeObject = ctx.lookup(accessName);
         // Get the AccessHome object.
            System.out.println("TL - doing narrowing");
                System.out.println("TL - homeObject:" + homeObject.toString());
         aHome = (AccessHome)javax.rmi.PortableRemoteObject.narrow(homeObject, WebSphereSamples.YourCo.Timeout.AccessHome.class);
     System.out.println("TL - woo hoo");
         }
      // Determine cause of failure
      catch (NamingException e)
      {
         System.out.println("getAccessHome NamingException: " + e.getMessage() );
         e.printStackTrace();
      }
      catch (Exception e)
      {
         System.out.println("getAccessHome Exception: "+ e.getMessage() ); 
         e.printStackTrace();
      }
      return aHome;
}
/**
 * Insert the method's description here.
 * Creation date: (9/14/2001 6:44:05 PM)
 * @return java.lang.String
 * @param param1 javax.servlet.http.HttpServletRequest
 * @param param2 java.lang.String
 * @param param3 boolean
 * @param param4 boolean
 * @param param5 boolean
 * @param param6 java.lang.String
 * @exception java.lang.Exception The exception description.
 */
public String getParameter(
    HttpServletRequest param1,
    String param2,
    boolean param3,
    boolean param4,
    boolean param5,
    String param6)
    throws java.lang.Exception {

    if (param1 != null)
        return super.getParameter(param1, param2, param3, param4, param5, param6);
    else {
        String ejbProperty = null;
        String ejbPropName = "ejbLocation";

        try {
            /*System.out.println("look in: " + controlPropName +
            					" for: " + controlProperty);*/
            PropertyResourceBundle resourceBundle =
                (PropertyResourceBundle) PropertyResourceBundle.getBundle(ejbPropName);
            ejbProperty = resourceBundle.getString(param2);

        } catch (Exception e) {

            System.out.println(
                (new java.util.Date())
                    + " get ejb location info - Unexpected exception ");
            System.out.println("    accessing info file: " + ejbPropName);
            System.out.println("    error getting: " + param2);
            throw new Exception(
                "Unexpected exception whilst accessing info file "
                    + ejbPropName
                    + ": "
                    + e);
        }
        return ejbProperty;
    }

}
/**
 * Insert the method's description here.
 * Creation date: (9/14/2001 6:57:16 PM)
 * @param args java.lang.String[]
 */
public static void main(String[] args) {
	TotalLeaveServlet totalLeaveServlet = new TotalLeaveServlet();
	   Access access = null;
    try {
        int ii = 0;
        int totalVactional = 0;
        int totalPersonal = 0;
        int totalSick = 0;

    //    HttpSession session = request.getSession(true);
    //    WebSphereSamples.YourCo.Login.SessionBean sessionBean = null;
   //     sessionBean =
   //         (WebSphereSamples.YourCo.Login.SessionBean) session.getValue("sessionBean");

   //     if (sessionBean == null) {
   //         callPage("NotLoggedIn", request, response);
   //     }

        TotalLeaveBean totalLeaveInfo = new TotalLeaveBean();

        totalLeaveInfo = totalLeaveServlet.calcTotalLeave(null);

   
        System.out.println("TL - Page Name: " );
      
    } // End Try

    //    catch (Throwable theException) {
    // uncomment the following line when unexpected exceptions are occuring to aid in debugging the problem
    // theException.printStackTrace();

    // handleError(request, response, theException);
    //  }
    // } // End Else
//} // End main try  
catch (Exception e) {
    System.out.println("Exception: " + e.getMessage());
    e.printStackTrace();
}
	}
/*****************************************************************************
* Process incoming requests for information
* 
* @param request Object that encapsulates the request to the servlet
* @param response Object that encapsulates the response from the servlet
*/
public void performTask(
    HttpServletRequest request,
    HttpServletResponse response) {
    Access access = null;
    try {
        int ii = 0;
        int totalVactional = 0;
        int totalPersonal = 0;
        int totalSick = 0;

        HttpSession session = request.getSession(true);
        WebSphereSamples.YourCo.Login.SessionBean sessionBean = null;
        sessionBean =
            (WebSphereSamples.YourCo.Login.SessionBean) session.getValue("sessionBean");

        if (sessionBean == null) {
            callPage("NotLoggedIn", request, response);
        }

        TotalLeaveBean totalLeaveInfo = new TotalLeaveBean();

        totalLeaveInfo = calcTotalLeave(request);

        setRequestAttribute("totalLeaveInfo", totalLeaveInfo, request);
        System.out.println("TL - Page Name: " + getPageNameFromRequest(request));
        callPage(getPageNameFromRequest(request), request, response);
    } // End Try

    //    catch (Throwable theException) {
    // uncomment the following line when unexpected exceptions are occuring to aid in debugging the problem
    // theException.printStackTrace();

    // handleError(request, response, theException);
    //  }
    // } // End Else
//} // End main try  
catch (Exception e) {
    System.out.println("Exception: " + e.getMessage());
    e.printStackTrace();
}
}
}
