package itso.mqe.chatserver;

/**
 * Insert the type's description here.
 * Creation date: (9/17/2001 11:39:51 AM)
 * @author: Administrator
 */

import com.ibm.mqe.*;
import java.util.*;
import itso.mqe.chatwindow.*;
public class RoomMgr
    extends MQe
    implements MQeRunListInterface, Runnable, MQeMessageListenerInterface {
    Thread th = null;
    MQeQueueManager qmgr = null;
    RoomWindow itsoChatRoom = null;
    String eventQMgr = null;
    String eventQueueName = null;
    String originQMgr = null;
    boolean firstMsg = true;
    String clientQueue = "ChatClientQ";
    String chatRoomQ = "ChatRoomQ";

/**
 * HelloWorld constructor comment.
 */
public RoomMgr() {
	super();
}
/**
 * Insert the method's description here.
 * Creation date: (9/17/2001 11:47:25 AM)
 * @return java.lang.Object
 * @param owner java.lang.Object
 * @param setupData com.ibm.mqe.MQeFields
 */
public Object activate(Object owner, Hashtable loadTable, MQeFields setupData) {

	System.out.println("RoomMgr - activating...");
	
	qmgr = (MQeQueueManager) owner;    /* Qmgr is owner of the application */
	//processSetupData(setupData); 		/*Process the setup information */

	if (setupData != null) {
		Enumeration enum = setupData.fields();
		try {
			while (enum.hasMoreElements())
			{
				String fieldName = (String) enum.nextElement();
				String value = setupData.getAscii(fieldName);
				System.out.println("Field name: " + fieldName +
								" value: " + value);
			}
		}
		catch (Exception e) {
			System.out.println("Error accessing application set up data" + e);
		}
	}

	th = new Thread(this);				/* Create a new thread to listen for */
	th.start();							/* incoming messages */
	return (null);						/* Return control to QMgr */
	
}
/**
 * Insert the method's description here.
 * Creation date: (9/17/2001 12:10:43 PM)
 * @param e com.ibm.mqe.MQeMessageEvent
 */
public void messageArrived(MQeMessageEvent e) {

	if (firstMsg) {
		itsoChatRoom.enableInput();
		firstMsg = false;
	}
    eventQMgr = e.getQueueManagerName(); /*get id of Qmgr msg from */
    System.out.println("eQmgr: " + eventQMgr);
    eventQueueName = e.getQueueName(); /*get queue name */
    try {
        MQeMsgObject msgObj = qmgr.getMessage(null, chatRoomQ, null, null, 0);
        /* get the message */

        if (originQMgr == null)
            originQMgr = msgObj.getOriginQMgr();

        System.out.println(
            "From: " + eventQMgr + " : " + eventQueueName
                + "Really: " + originQMgr + " msg: "
                + msgObj.getAscii("Message"));
        
        itsoChatRoom.showReceivedMsg("From: " + originQMgr + " : " +
	        			msgObj.getAscii("Message"));

    } catch (MQeException ex) {
        System.out.println("Error getting msg" + ex);
    } catch (Exception ex) {
        System.out.println("Error getting msg" + ex);
    }
}
/**
 * Insert the method's description here.
 * Creation date: (9/17/2001 11:53:55 AM)
 */
public void run() {

    System.out.println("Creating chat window");

    if (itsoChatRoom == null) {
        itsoChatRoom = new RoomWindow(this);
        itsoChatRoom.showChatWindow();
        itsoChatRoom.sendChatMsg();
        itsoChatRoom.setupWasInputListener();
    }
    try {

        qmgr.addMessageListener(this, chatRoomQ, null);

    } catch (Exception e) {
        e.printStackTrace(System.err);
    }
}
/**
 * Insert the method's description here.
 * Creation date: (9/17/2001 5:47:08 PM)
 * @param message java.lang.String
 */
public void sendMessage(String message) {
    //String eventQMgr = e.getQueueManagerName();		/*get id of Qmgr msg from */
    //String eventQueueName = e.getQueueName();		/*get queue name */
    try {
        System.out.println("Msg to send: " + message);

        MQeMsgObject msgObj = new MQeMsgObject();
        msgObj.putAscii("Message", message); /* set up the message */
        eventQMgr = "ClientQm";
        System.out.println("Sending to: " + eventQMgr + " PUT: " + message);
        //	eventQMgr = e.getQueueManagerName();		/*get id of Qmgr msg from */
        //eventQueueName = e.getQueueName();		/*get queue name */
        //qmgr.putMessage(eventQMgr, eventQueueName + "Reply", msgObj, null, 0);	/* send the message */
        qmgr.putMessage(originQMgr, clientQueue, msgObj, null, 0); /* send the message */
        System.out.println("Sent: " + " msg: " + msgObj.getAscii("Message"));
    } catch (MQeException ex) {
        System.out.println("MQe Error sending msg" + ex);
    } catch (Exception ex) {
        System.out.println("Error sending msg" + ex);
    }
}
/**
 * Insert the method's description here.
 * Creation date: (9/17/2001 5:47:08 PM)
 * @param message java.lang.String
 */
public void sendMessage(String viaWasFlag, String message) {
	String targQ = null;
	String targQAsync = null;
	String targQMgr = null;

	if (viaWasFlag == null) {
		targQ = "ChatClientQ";
		targQMgr = "ClientQm";
	}
	else {
		targQ = "ChatClientQViaWas";
		targQMgr = "WASServerQm";

	}

	
    //String eventQMgr = e.getQueueManagerName();		/*get id of Qmgr msg from */
    //String eventQueueName = e.getQueueName();		/*get queue name */
    try {
        System.out.println("Msg to send: " + message);

        MQeMsgObject msgObj = new MQeMsgObject();
        msgObj.putAscii("Message", message); /* set up the message */
       
        System.out.println("Sending to: " + targQMgr + " PUT: " + message);
        //	eventQMgr = e.getQueueManagerName();		/*get id of Qmgr msg from */
        //eventQueueName = e.getQueueName();		/*get queue name */
        //qmgr.putMessage(eventQMgr, eventQueueName + "Reply", msgObj, null, 0);	/* send the message */
        qmgr.putMessage(targQMgr, targQ, msgObj, null, 0); /* send the message */
        System.out.println("Sent: " + " msg: " + msgObj.getAscii("Message"));
    } catch (MQeException ex) {
        System.out.println("MQe Error sending msg" + ex);
    } catch (Exception ex) {
        System.out.println("Error sending msg" + ex);
    }
}
/**
 * Insert the method's description here.
 * Creation date: (9/17/2001 5:33:14 PM)
 * @param qmgr com.ibm.mqe.MQeQueueManager
 */
public void setQueueMgr(MQeQueueManager qmgrId) {
	 qmgr = qmgrId;}
}
